mod Ex09

incl Mtex

incl Mtexrc

loc rem 
  \para \bf  9. CVICENIE Z PREDMETU M-INBP-004 TEORIA VYPOCITATELNOSTI PRE 
  PROGRAMATOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 23.11.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/M-INBP-004-vyp/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane 
  \ft Texm_f0_mu \end-rekurzivnym funkciam. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 2 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 1 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/M-INBP-004-vyp/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 5.12.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end P. J. Voda. Theory of Recursive Functions & 
         Computability. 2000. 
   \item \para \it  [3]  \end I. Korec. Uvod do teorie algoritmov. MFF UK. 
         Bratislava. 1983. 
  \end

rem 
  \para \bf  [CL] Syntax.  \end See the module \it  Mclsyntax  \end in the file 
  \it  mclsyntax.cl  \end. 

rem 
  \para \bf  Chapter. Recursive Functions.  \end 

rem 
  \para \bf  Section. \ft Texm_f0_mu \end- Recursive Functions.  \end 

rem 
  \para \bf  Alternative definition of  \end \ft Texm_f0_mu \end \bf  -recursive 
  functions.  \end 

fun/2 Ltf 'Tex_f2_char_ltf'
  Ltf(x,y) = 1 <- x < y
  Ltf(x,y) = 0 <- x >= y

rem 
  \para The class of \ft Texm_f0_mu \end-recursive functions is generated from 
  the identity functions, the multiplication function \ft x*y \end and the 
  characteristic function \ft Ltf(x,y) \end of the predicate \ft x < y \end by 
  composition and regular minimalization of functions. 

rem 
  \para \bf  Theorem.  \end \ft Texm_f0_mu \end-recursive functions are closed 
  under explicit definitions of functions without constants. 

rem 
  \para \bf  Theorem.  \end \ft Texm_f0_mu \end-recursive functions are closed 
  under regular minimalization of the form 
  \def 
    fun F 'Tex_f1_f'
    F(x) = \m y [ Texm_f0_tau = 1 ]
  \end
  \para where the term \ft Texm_f0_tau \end is without constants. 

rem 
  \para \bf  Exercise.  \end \header* fun Ss 'Tex_f1_rec_ss' \end Show that the 
  successor function \ft Ss(x) = x+1 \end is \ft Texm_f0_mu \end-recursive. 

fun Ss 'Tex_f1_rec_ss'
  Ss(x) = Foo

rem 
  \para \bf  Exercise.  \end Show that unary constant functions are 
  \ft Texm_f0_mu \end-recursive. 
  \para \it  Remark.  \end Prove the claim for the following functions. 

fun Z 
  Z(x) = Foo

fun C1 
  C1(x) = Foo

fun C2 
  C2(x) = Foo

fun C3 
  C3(x) = Foo

rem 
  \para \bf  Theorem.  \end \ft Texm_f0_mu \end-recursive functions are closed 
  under explicit definitions of functions (with constants). 

rem 
  \para \bf  Theorem.  \end \ft Texm_f0_mu \end-recursive functions are closed 
  under regular minimalizations of the form 
  \def 
    fun F 'Tex_f1_f'
    F(x) = \m y [ Texm_f0_tau = 1 ]
  \end
  \para where the term \ft Texm_f0_tau \end may contain constants. 

rem 
  \para \bf  Exercise.  \end Show that boolean functions are 
  \ft Texm_f0_mu \end-recursive. 

fun Notf 'Tex_f1_bool_notf'
  Notf(x) = Foo

fun/2 Andf 'Tex_f2_bool_andf'
  Andf(x,y) = Foo

fun/2 Orf 'Tex_f2_bool_orf'
  Orf(x,y) = Foo

fun/2 Impf 'Tex_f2_bool_impf'
  Impf(x,y) = Foo

fun/2 Ifff 'Tex_f2_bool_ifff'
  Ifff(x,y) = Foo

rem 
  \para \bf  Exercise.  \end Show that the following comparison predicates are 
  \ft Texm_f0_mu \end-recursive. 

fun/2 Lef 'Tex_f2_char_lef'
  Lef(x,y) = Foo

fun/2 Eqf 'Tex_f2_char_eqf'
  Eqf(x,y) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/3 D1 'Tex_f3_rec_d1' \end Show that 
  the case discrimination function \ft D1(x,y,z) \end is 
  \ft Texm_f0_mu \end-recursive. 

fun/3 D1 'Tex_f3_rec_d1'
  D1(x,y,z) = Foo

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end Show that 
  \ft Texm_f0_mu \end-recursive functions are closed under the operator of 
  bounded minimalization. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 
  \para \it  Poznamka k hodnoteniu.  \end Tu mozte predpokladat, ze 
  predchadzajuce priklady su vyriesene. 

theory Operator_of_bounded_minimalization

fun/2 G 'Tex_f2_g'

rem 
  \para \header* fun/2 F 'Tex_f2_f' \end Suppose that \ft G(z,y) \end is a 
  \ft Texm_f0_mu \end-recursive function. Show that the function \ft F(x,y) \end 
  defined as 
  \def 
    fun/2 F 'Tex_f2_f'
    F(x,y) = \m z <= x [ G(z,y) = 1 ]
  \end
  \para is \ft Texm_f0_mu \end-recursive. 

fun/2 F 'Tex_f2_f'
  F(x,y) = Foo

end theory Operator_of_bounded_minimalization

rem 
  \para \bf  Theorem.  \end \ft Texm_f0_mu \end-recursive predicates are closed 
  under explicit definitions of predicates with bounded formulas. 

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin comparison 
  predicates. 

rem 
  \para \bf  Theorem.  \end \ft Texm_f0_mu \end-recursive functions are closed 
  under definitions of functions with bounded minimalization. 

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end Show that the addition 
  function \ft x+y \end is \ft Texm_f0_mu \end-recursive. 

fun/2 Plus 'Tex_f2_n_plus'
  Plus(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x+y \end. 

rem 
  \para \bf  Exercise.  \end Show that the modified subtraction function 
  \ft x-y \end is \ft Texm_f0_mu \end-recursive. 

fun/2 Minus 'Tex_f2_n_minus'
  Minus(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x-y \end. 

rem 
  \para \bf  Exercise.  \end Show that the integer division function 
  \ft x/y \end is \ft Texm_f0_mu \end-recursive. Recall that \ft x/0 = 0 \end. 

fun/2 Div 'Tex_f2_n_div'
  Div(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x/y \end. 

rem 
  \para \bf  Exercise.  \end \header* fun Sum 'Tex_f1_n_sum' \end Show that the 
  summation function \ft Sum(n) \end is \ft Texm_f0_mu \end-recursive. 

fun Sum 'Tex_f1_n_sum'
  Sum(n) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Pair 'Tex_f2_pp_pair' \end Show that 
  the modified Cantor pairing function \ft Pair(x,y) \end is 
  \ft Texm_f0_mu \end-recursive. 

fun/2 Pair 'Tex_f2_pp_pair'
  Pair(x,y) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Proj1 'Tex_f1_pp_proj1' \end Show that 
  the first projection \ft Proj1(x) \end of the pairing function is 
  \ft Texm_f0_mu \end-recursive. 

fun Proj1 'Tex_f1_pp_proj1'
  Proj1(x) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Proj2 'Tex_f1_pp_proj2' \end Show that 
  the second projection \ft Proj2(x) \end of the pairing function is 
  \ft Texm_f0_mu \end-recursive. 

fun Proj2 'Tex_f1_pp_proj2'
  Proj2(x) = Foo

rem 
  \para \bf  Theorem.  \end \header* fun Iproj2 'Tex_f2_pp_iproj2' \end The 
  iteration of \ft Proj2(x) \end is \ft Texm_f0_mu \end-recursive. 

fun/2 Iproj2 'Tex_f2_pp_iproj2'
  Iproj2(0,x) = x
  Iproj2(n+1,x) = Proj2 Iproj2(n,x)

rem 
  \para \bf  Exercise.  \end \header* fun/2 Sub 'Tex_f2_pp_sub' \end Show that 
  the indexing function \ft Sub(x,i) \end is \ft Texm_f0_mu \end-recursive. 

fun/2 Sub 'Tex_f2_pp_sub'
  Sub(x,i) = Foo

rem 
  \para \bf  Exercise.  \end Show that the sequence length function 
  \ft L(x) \end is \ft Texm_f0_mu \end-recursive. 

fun L 
  L(x) = Foo

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end Show that 
  \ft Texm_f0_mu \end-recursive functions are closed under the operator of 
  primitive recursion. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 
  \para \it  Poznamka k hodnoteniu.  \end Tu mozte predpokladat, ze 
  predchadzajuce priklady su vyriesene. 

theory Operator_of_primitive_recursion

fun G 'Tex_f1_g'

fun/3 H1 'Tex_f3_h'

rem 
  \para \header* fun/2 F 'Tex_f2_f' \end Suppose \ft G(y) \end and 
  \ft H1(x,a,y) \end are \ft Texm_f0_mu \end-recursive functions. Show that the 
  function \ft F(x,y) \end defined by 
  \def 
    fun/2 F 'Tex_f2_f'
    F(0,y) = G(y)
    F(x+1,y) = H1(x,F(x,y),y)
  \end
  \para is \ft Texm_f0_mu \end-recursive. 

fun/2 F 'Tex_f2_f'
  F(x,y) = Foo

end theory Operator_of_primitive_recursion

rem 
  \para \bf  Theorem.  \end \ft Texm_f0_mu \end-recursive functions are 
  primitively recursively closed. 

rem 
  \para \bf  Corollary.  \end Primitive recursive functions are 
  \ft Texm_f0_mu \end-recursive. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

loc rem 
  \para Formats for testing binary functions and predicates. Examples of usage: 
  \items 
   \item \para define \ft Test_fun(x) = H(x)+T(x) \end and run query \it  
         Itf(10)=x:Lf2  \end 
   \item \para define \ft Test_pred(x) <-> H(x) <= T(x) \end and run query \it  
         Itp(10)=x:Lp2  \end 
  \end

loc pred Nn 
  Nn(0)
  Nn(x1,x2) <- N(x1) & N(x2)

loc pred Nnn 
  Nnn(x,y) <- Nn(x) & N(y)

loc pred Lf2 
  Lf2(0)
  Lf2(v,w) <- Nnn(v) & Lf2(w)

loc pred Lp2 
  Lp2(0)
  Lp2(v,w) <- Nn(v) & Lp2(w)

